namespace CMSMicroservice.Application.UserContractCQ.Commands.CreateNewUserContract;
public class CreateNewUserContractCommandValidator : AbstractValidator<CreateNewUserContractCommand>
{
    public CreateNewUserContractCommandValidator()
    {
        RuleFor(model => model.UserId)
            .NotNull();
        RuleFor(model => model.ContractId)
            .NotNull();
        RuleFor(model => model.SignGuid)
            .NotEmpty();
        RuleFor(model => model.SignedPdfFile)
            .NotEmpty();
    }
    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(ValidationContext<CreateNewUserContractCommand>.CreateWithOptions((CreateNewUserContractCommand)model, x => x.IncludeProperties(propertyName)));
        if (result.IsValid)
            return Array.Empty<string>();
        return result.Errors.Select(e => e.ErrorMessage);
    };
}
